# layout of boot.img

### 1. header part

              item                        size in bytes             position
    +----------------------------------------------------------+    --> 0
    |<MAGIC HEADER>                  |     8                   |
    |--------------------------------+-------------------------|    --> 8
    |<kernel length>                 |     4                   |
    |--------------------------------+-------------------------|    --> 12
    |<kernel offset>                 |     4                   |
    |--------------------------------+-------------------------|    --> 16 (0x10)
    |<ramdisk length>                |     4                   |
    |--------------------------------+-------------------------|    --> 20
    |<ramdisk offset>                |     4                   |
    |--------------------------------+-------------------------|    --> 24
    |<second bootloader length>      |     4                   |
    |--------------------------------+-------------------------|    --> 28
    |<second bootloader offset>      |     4                   |
    |--------------------------------+-------------------------|    --> 32 (0x20)
    |<tags offset>                   |     4                   |
    |--------------------------------+-------------------------|    --> 36
    |<page size>                     |     4                   |
    |--------------------------------+-------------------------|    --> 40
    |<header version>                |     4                   |
    |--------------------------------+-------------------------|    --> 44
    |<os version& os patch level>    |     4                   |
    |--------------------------------+-------------------------|    --> 48 (0x30)
    |<board name>                    |     16                  |
    |--------------------------------+-------------------------|    --> 64 (0x40)
    |<cmdline part 1>                |     512                 |
    |--------------------------------+-------------------------|    --> 576 (0x240)
    |<hash digest>                   |     32                  |
    |--------------------------------+-------------------------|    --> 608 (0x260)
    |<cmdline part 2>                |     1024                |
    |--------------------------------+-------------------------|    --> 1632 (0x660)
    |<dtbo length>                   |     4                   |
    |--------------------------------+-------------------------|    --> 1636
    |<dtbo offset>                   |     8                   |
    |--------------------------------+-------------------------|    --> 1644
    |<header size>                   |     4                   |
    |--------------------------------+-------------------------|    --> 1648 (0x670)
    |<padding>                       | min(n * page_zie - 1648)|
    +----------------------------------------------------------+    --> pagesize

### 2. data part

    +----------------------------------------------------------+    --> pagesize
    |<kernel>                        |   kernel length         |
    |--------------------------------+-------------------------|
    |<padding>                       |  min(n * page_zie - len)|
    +----------------------------------------------------------+

    +--------------------------------+-------------------------+
    |<ramdisk>                       |   ramdisk length        |
    |--------------------------------+-------------------------|
    |<padding>                       |  min(n * page_zie - len)|
    +----------------------------------------------------------+

    +--------------------------------+-------------------------+
    |<second bootloader>             | second bootloader length|
    |--------------------------------+-------------------------|
    |<padding>                       |  min(n * page_zie - len)|
    +----------------------------------------------------------+

    +--------------------------------+-------------------------+
    |<recovery dtbo>                 | recovery dtbo length    |
    |--------------------------------+-------------------------|
    |<padding>                       |  min(n * page_zie - len)|
    +----------------------------------------------------------+

### 3. signature part

#### 3.1 Boot Image Signature (VBoot 1.0)

    +--------------------------------+-------------------------+
    |<signature>                     | signature length        |
    |--------------------------------+-------------------------|
    |<padding>                       | defined by boot_signer  |
    +----------------------------------------------------------+

#### 3.2 AVB Footer (VBoot 2.0)

    +--------------------------------+-------------------------+
    |<signature>                     | signature length        |
    |--------------------------------+-------------------------|
    | ...                            | ...                     |
    |<padding>                       | defined by avbtool,     |
    |<padding>                       | it will pad to requested|
    |<padding>                       | image size              |
    | ...                            | ...                     |
    +----------------------------------------------------------+
